/* initialize connection to server, get its Desktop-service and XComponentLoader interface */
xMsf=ooo.connect()   -- connect to server and retrieve remote multi server factory

-- Retrieve the Desktop object, we need its XComponentLoader interface
-- to load a new document
oDesktop         = xMsf~createInstance("com.sun.star.frame.Desktop")
xDesktop         = oDesktop~XDesktop          -- get desktop interface
xComponentLoader = xDesktop~XComponentLoader  -- get componentLoader interface

-- ---------- End of connection header ---------------

-- Open the "sdraw" application
oDrawComponent = xComponentLoader~loadComponentFromURL("private:factory/sdraw", "_blank", 0, .OOo~noProps)

-- Get draw page by index
oDrawPage=oDrawComponent~XDrawPagesSupplier ~getDrawPages ~getByIndex(0)
xDrawPage=oDrawPage~xDrawPage

-- Find out page dimensions
xPageProps=xDrawPage~XPropertySet

pageWidth       = xPageProps~getPropertyValue("Width")
pageHeight      = xPageProps~getPropertyValue("Height")
pageBorderTop   = xPageProps~getPropertyValue("BorderTop")
pageBorderLeft  = xPageProps~getPropertyValue("BorderLeft")
pageBorderRight = xPageProps~getPropertyValue("BorderRight")
drawWidth       = pageWidth - pageBorderLeft - pageBorderRight
horCenter       = pageBorderLeft + drawWidth / 2

-- Make up some data for organigram
orgUnits.1.1 = "Management" -- level 0
orgUnits.2.1 = "Production"
orgUnits.2.2 = "Purchasing"
orgUnits.2.3 = "IT Services"
orgUnits.2.4 = "Sales"    -- level 1
levelCount.1 = 1
levelCount.2 = 4

-- Calculate shape, sizes and positions
horSpace = 300
verSpace = 3000
shapeWidth = (drawWidth - (levelCount.2 - 1) * horSpace) / levelCount.2
shapeHeight = pageHeight / 20
shapeX = pageWidth / 2 - shapeWidth / 2
levelY = 0
xStartShape = .nil

-- Get document factory
xDrawFactory=oDrawComponent~XMultiServiceFactory

-- Creating and adding RectangleShapes and Connectors
do level=1 to 2
	levelY = pageBorderTop + 2000 + level * (shapeHeight + verSpace)
	levelY = format(levelY, ,0) --rgf, round

	do i=levelCount.level to 1 by -1
		shapeX = horCenter - ,
				(levelCount.level * shapeWidth + (levelCount.level - 1) * ,
				horSpace) / 2 + ,
				(i-1) * shapeWidth + (i-1) * horSpace
		shape = xDrawFactory~createInstance("com.sun.star.drawing.RectangleShape")

      xShape=shape~XShape
		shapeX = format(shapeX, , 0)

		xShape~setPosition(.bsf~new("com.sun.star.awt.Point", shapeX, levelY))
		shapeWidth = format(shapeWidth, , 0)
		shapeHeight = format(shapeHeight, , 0)
		xShape~setSize(.bsf~new("com.sun.star.awt.Size", shapeWidth, shapeHeight))
		xDrawPage~add(xShape)

		-- Set the text
      xShape~XText ~setString(orgUnits.level.i)

		-- Memorize the root shape, for connectors
		if level = 1 & i = 1 then xStartShape = xShape

		-- Add connectors for level 1
		if level = 2 then
		do
			connector = xDrawFactory~createInstance("com.sun.star.drawing.ConnectorShape")
         XConnector=connector~XShape

			xDrawPage~add(xConnector)
         xConnectorProps=connector~XPropertySet

			-- xConnectorProps~bsf.invokeStrict("setPropertyValue", "ST", "StartShape", "O", xStartShape)
         xConnectorProps~setPropertyValue("StartShape", xStartShape)

			-- xConnectorProps~bsf.invokeStrict("setPropertyValue", "ST", "EndShape", "O", xShape)
         xConnectorProps~setPropertyValue("EndShape",   xShape)

			-- glue point positions: 0=top 1=left 2=bottom 3=right
			xConnectorProps~setPropertyValue("StartGluePointIndex", bsf.box("Integer", 2)) -- .bsf~new("java.lang.Integer", 2))
			xConnectorProps~setPropertyValue("EndGluePointIndex",   bsf.box("Integer", 0)) -- .bsf~new("java.lang.Integer", 0))
		end
	end
end


::requires OOO.CLS   -- ooRexx support for OpenOffice.org
