
/* initialize connection to server, get its Desktop-service and XComponentLoader interface */
xMsf=OOo.connect()   -- connect to server and retrieve remote multi server factory

-- Retrieve the Desktop object, we need its XComponentLoader interface
-- to load a new document
loader = xMsf~createInstance("com.sun.star.frame.Desktop")~XComponentLoader  -- get componentLoader interface

-- ---------- End of connection header ---------------

/* load an empty text document */
oTextComponent = loader~loadComponentFromURL("private:factory/swriter", "_blank", 0, .OOo~noProps)

objDocument=oTextComponent~XTextDocument
objText=objDocument~getText

--------------------------------------------------------------------------------
-- Create a cursor object
objCursor= objText~createTextCursor()

-- Inserting some Text
objText~insertString(objCursor, "The first line in the newly created text document."||"0A"X, .false)

-- Inserting a second line
objText~insertString(objCursor, "Now we're in the second line", .false)


-- Create instance of a text table with 4 columns and 4 rows
objTable= objDocument~XMultiServiceFactory~createInstance("com.sun.star.text.TextTable")~xTextTable
objTable~initialize(4, 4)

-- Insert the table
objText~insertTextContent(objCursor, objTable, .false)

-- Get first row
objRows = objTable~getRows()
objRow = objRows~getByIndex(0)

-- Set the table background color
objTable~xPropertySet~setPropertyValue("BackTransparent", bsf.box("bool", .false))
objTable~xPropertySet~setPropertyValue("BackColor", bsf.box("int",13421823))

-- Set a different background color for the first row
objRow~xPropertySet~setPropertyValue("BackTransparent", bsf.box("bool", .false))
objRow~xPropertySet~setPropertyValue("BackColor", bsf.box("int", 6710932))

/*
   -- test the xPropertySet aspect a little bit...
aha=objRow~xPropertySet
say aha~string
say aha~tostring
say aha~getPropertyValue("BackColor")
say objRow~xPropertySet~getPropertyValue("BackColor")

psi=aha~getPropertySetInfo
props=psi~getProperties
say "props:" props~string "number of properties:" props~items
w=props~items~length
do i=1 to props~items
   say "prop #" i~right(w)": name=["props[i]~name"] type=["props[i]~type~string"] type~toString=["props[i]~type~toString"]"

end
*/

-- Fill the first table row
call insertIntoCell "A1", "FirstColumn", objTable
call insertIntoCell "B1", "SecondColumn", objTable
call insertIntoCell "C1", "ThirdColumn", objTable
call insertIntoCell "D1", "SUM", objTable

objTable~getCellByName("A2")~setValue(22.5)
objTable~getCellByName("B2")~setValue(5615.3)
objTable~getCellByName("C2")~setValue(-2315.7)
objTable~getCellByName("D2")~setFormula("sum <A2:C2>")

objTable~getCellByName("A3")~setValue(21.5)
objTable~getCellByName("B3")~setValue(615.3)
objTable~getCellByName("C3")~setValue(-315.7)
objTable~getCellByName("D3")~setFormula("sum <A3:C3>")

objTable~getCellByName("A4")~setValue(121.5)
objTable~getCellByName("B4")~setValue(-615.3)
objTable~getCellByName("C4")~setValue(415.7)
objTable~getCellByName("D4")~setFormula("sum <A4:C4>")

-- Change the CharColor and add a Shadow
objCursor~xPropertySet~setPropertyValue("CharColor", bsf.box("int", 255))
objCursor~xPropertySet~setPropertyValue("CharShadowed", bsf.box("bool", .true))

-- Create a paragraph break
PARAGRAPH_BREAK = 0
objText~insertControlCharacter(objCursor, PARAGRAPH_BREAK, .false)

-- Inserting colored Text.
objText~insertString(objCursor, "This is a colored Text - blue with shadow" ||"0A"X, .false)

-- Create a paragraph break (ControlCharacter::PARAGRAPH_BREAK).
objText~insertControlCharacter(objCursor, PARAGRAPH_BREAK, .false)

-- Create a TextFrame.
objTextFrame = objDocument~XMultiServiceFactory~createInstance("com.sun.star.text.TextFrame")~XTextFrame

-- Create a Size struct.
objTextFrame~xPropertySet~setPropertyValue("FrameHeightAbsolute", bsf.box("int", 400))
objTextFrame~xPropertySet~setPropertyValue("FrameWidthAbsolute",  bsf.box("int", 15000))

-- TextContentAnchorType.AS_CHARACTER = 1
AS_CHARACTER = 1
objTextFrame~xPropertySet~setPropertyValue("AnchorType", bsf.box("int", AS_CHARACTER))

-- insert the frame
objText~insertTextContent(objCursor, objTextFrame, .false)

-- Get the text object of the frame
objFrameText = objTextFrame~getText

-- Create a cursor object
objFrameTextCursor = objFrameText~createTextCursor

-- Inserting some Text
objFrameText~insertString(objFrameTextCursor, "The first line in the newly created text frame.", .false)
objFrameText~insertString(objFrameTextCursor, "0A"X || "With this second line the height of the frame raises.", .false)

-- Create a paragraph break
objFrameText~insertControlCharacter(objCursor, PARAGRAPH_BREAK , .false)

-- Change the CharColor and do not show a Shadow
objCursor~xPropertySet~setPropertyValue("CharColor", bsf.box("int", 65536))
objCursor~xPropertySet~setPropertyValue("CharShadowed", bsf.box("bool", .false))


-- Insert another string
objText~insertString(objCursor, " That' s all for now !!", .false)

EXIT

insertIntoCell: PROCEDURE
	use arg strCellName, strText, objTable
	objCellText = objTable~getCellByName(strCellName)~XText
	objCellCursor = objCellText~createTextCursor()
	objCellCursor~xPropertySet~setPropertyValue("CharColor", bsf.box("int", 16777215))
	objCellText~insertString(objCellCursor, strText, .false)
	RETURN


::requires OOO.CLS   -- ooRexx support for OpenOffice.org
